local function onResourceStart()
	--clearChat()
	setPlayerHudComponentVisible("weapon", false)
	setPlayerHudComponentVisible("ammo", false)
	setPlayerHudComponentVisible("vehicle_name", false)
	setPlayerHudComponentVisible("money", false)
	setPlayerHudComponentVisible("clock", false)
	setPlayerHudComponentVisible("health", false)
	setPlayerHudComponentVisible("armour", false)
	setPlayerHudComponentVisible("breath", false)
	setPlayerHudComponentVisible("area_name", false)
	setPlayerHudComponentVisible("radar", false)
	setPlayerHudComponentVisible("crosshair", true)
	
	setAmbientSoundEnabled( "gunfire", false )
	
	setPedTargetingMarkerEnabled(false) -- Adams
	
	triggerServerEvent( "accounts:login:request", getLocalPlayer() )
end
addEventHandler( "onClientResourceStart", getResourceRootElement( ), onResourceStart )

--[[ XML STORAGE ]]--
local oldXmlFileName = "settings.xml"
local migratedSettingsFile = "@migratedsettings.empty"
local xmlFileName = "@settings.xml"
function loadSavedData(parameter, default)
	-- migrate existing settings
	if not fileExists(migratedSettingsFile) then
		if not fileExists(xmlFileName) and fileExists(oldXmlFileName) then
			fileRename(oldXmlFileName, xmlFileName)
		end
		fileClose(fileCreate(migratedSettingsFile))
	end
	local xmlRoot = xmlLoadFile( xmlFileName )
	if (xmlRoot) then
		local xmlNode = xmlFindChild(xmlRoot, parameter, 0)
		if (xmlNode) then
			return xmlNodeGetValue(xmlNode)
		end
	end
	return default or false
end

function appendSavedData(parameter, value)
	setElementData(getLocalPlayer(), parameter, value, false)
	local xmlFile = xmlLoadFile ( xmlFileName )
	if not (xmlFile) then
		xmlFile = xmlCreateFile( xmlFileName, "login" )
	end
	
	local xmlNode = xmlFindChild (xmlFile, parameter, 0)
	if not (xmlNode) then
		xmlNode = xmlCreateChild(xmlFile, parameter)
	end
	xmlNodeSetValue ( xmlNode, value )
	xmlSaveFile(xmlFile)
	xmlUnloadFile(xmlFile)
end

--MAXIME--
-- function loadSavedData3(parameter)
	-- for i = 2, 14, 2 do
		-- if loadSavedData(parameter, tostring(i*5)) then
			-- return loadSavedData(parameter, tostring(i*5))
		-- end
	-- end
	-- return "10"
-- end

--MAXIME

local BizNoteFont18 = dxCreateFont ( ":resources/BizNote.ttf" , 18 )

fontType = {-- (1)font (2)scale offset
	["default"] = {"default", 1},
	["default-bold"] = {"default-bold",1},
	["clear"] = {"clear",1.1},
	["arial"] = {"arial",1},
	["sans"] = {"sans",1.2},
	["pricedown"] = {"pricedown",3},
	["bankgothic"] = {"bankgothic",4},
	["diploma"] = {"diploma",2},
	["beckett"] = {"beckett",2},
	["BizNoteFont18"] = {"BizNoteFont18",1.1},
}

function loadSavedData2(parameter)
	
	for key, font in pairs(fontType) do
		local value = loadSavedData(parameter, font[1])
		if value then
			return value
		end
	end
	
	return false
end

--[[ END XML STORAGE ]]--

--[[ START ANIMATION STUFF ]]--
local happyAnims = {
	{ "ON_LOOKERS", "wave_loop"}
}

local idleAnims = {
	{ "PLAYIDLES", "shift"},
	{ "PLAYIDLES", "shldr"},
	{ "PLAYIDLES", "stretch"},
	{ "PLAYIDLES", "strleg"},
	{ "PLAYIDLES", "time"}
}

local danceAnims = {
	{ "DANCING", "dance_loop" }
}

local deathAnims = {
	{ "GRAVEYARD", "mrnF_loop" }	
}

function getRandomAnim( animType )
	if (animType == 1) then -- happy animations
		return happyAnims[ math.random(1, #happyAnims) ]
	elseif (animType == 2) then -- idle animations
		return idleAnims[ math.random(1, #idleAnims) ]
	elseif (animType == 3) then -- idle animations
		return danceAnims[ math.random(1, #danceAnims) ]
	elseif (animType == 4) then -- death animations
		return deathAnims[ math.random(1, #deathAnims) ]
	end
end
--[[ END ANIMATION STUFF ]]--

function clearChat()
	local lines = getChatboxLayout()["chat_lines"]
	for i=1,lines do
		outputChatBox("")
	end
end
addCommandHandler("clearchat", clearChat)



--MAXIME
function applyClientConfigSettings() 
	
	local borderVeh = tonumber( loadSavedData("borderVeh", "1") )
	setElementData(getLocalPlayer(), "borderVeh", borderVeh, false)
	
	local bgVeh = tonumber( loadSavedData("bgVeh", "1") )
	setElementData(getLocalPlayer(), "bgVeh", bgVeh, false)
	
	local bgPro = tonumber( loadSavedData("bgPro", "1") )
	setElementData(getLocalPlayer(), "bgPro", bgPro, false)
	
	local borderPro = tonumber( loadSavedData("borderPro", "1") )
	setElementData(getLocalPlayer(), "borderPro", borderPro, false)
	
	local enableOverlayDescription = tonumber( loadSavedData("enableOverlayDescription", "1") )
	setElementData(getLocalPlayer(), "enableOverlayDescription", enableOverlayDescription or 1, false)
	
	local enableOverlayDescriptionVeh = tonumber( loadSavedData("enableOverlayDescriptionVeh", "1") )
	setElementData(getLocalPlayer(), "enableOverlayDescriptionVeh", enableOverlayDescriptionVeh or 1, false)
	
	local enableOverlayDescriptionVehPin = tonumber( loadSavedData("enableOverlayDescriptionVehPin", "1") )
	setElementData(getLocalPlayer(), "enableOverlayDescriptionVehPin", enableOverlayDescriptionVehPin, false)
	
	local enableOverlayDescriptionPro = tonumber( loadSavedData("enableOverlayDescriptionPro", "1") )
	setElementData(getLocalPlayer(), "enableOverlayDescriptionPro", enableOverlayDescriptionPro or 1, false)
	
	local enableOverlayDescriptionProPin = tonumber( loadSavedData("enableOverlayDescriptionProPin", "1") )
	setElementData(getLocalPlayer(), "enableOverlayDescriptionProPin", enableOverlayDescriptionProPin or 1, false)
	
	local cFontPro = loadSavedData2("cFontPro")
	setElementData(getLocalPlayer(), "cFontPro", cFontPro or "BizNoteFont18", false)
	
	local cFontVeh = loadSavedData2("cFontVeh")
	setElementData(getLocalPlayer(), "cFontVeh", cFontVeh or "default", false)
	
	-- local sVeh = tonumber( loadSavedData3("sVeh", "sVeh") )
	-- setElementData(getLocalPlayer(), "sVeh", sVeh, false)
	
	-- local sPro = tonumber( loadSavedData3("sPro") )
	-- setElementData(getLocalPlayer(), "sPro", sPro, false)

	
	
	
	local blurEnabled = tonumber( loadSavedData("motionblur", "1") )
	if (blurEnabled == 1) then
		setBlurLevel(38)
	else
		setBlurLevel(0)
	end
	
	local skyCloudsEnabled = tonumber( loadSavedData("skyclouds", "1") )
	if (skyCloudsEnabled == 1) then
		setCloudsEnabled ( true )
	else
		setCloudsEnabled ( false )
	end
	
	local streamingMediaEnabled = tonumber(loadSavedData("streamingmedia", "1"))
	if streamingMediaEnabled == 1 then
		setElementData(getLocalPlayer(), "streams", 1, true)
	else
		setElementData(getLocalPlayer(), "streams", 0, true)
	end

	local phone_anim = tonumber(loadSavedData("phone_anim", "1"))
	if phone_anim == 1 then
		setElementData(getLocalPlayer(), "phone_anim", 1, true)
	else
		setElementData(getLocalPlayer(), "phone_anim", 0, true)
	end
	--[[
	local setNametagsEnabled = tonumber( loadSavedData("shownametags", "1") )
	if (setNametagsEnabled == 1) then
		setNametagsEnabled ( true )
	else
		setNametagsEnabled ( false )
	end]]
end
--addEventHandler("accounts:settings:loadGraphicSettings", getRootElement(), applyClientConfigSettings)
--addEventHandler("onClientResourceStart", getRootElement(), applyClientConfigSettings)

-- For the skin selection
blackMales = {1}
whiteMales = {1}
asianMales = {1}
blackFemales = {1}
whiteFemales = {1}
asianFemales = {1}

local screenX, screenY = guiGetScreenSize( )
local label = guiCreateLabel( 0, 0, screenX, 15, "FALCON", false )
guiSetSize( label, guiLabelGetTextExtent( label ) + 5, 14, false )
guiSetPosition( label, screenX - guiLabelGetTextExtent( label ) - 5, screenY - 27, false )
guiSetAlpha( label, 0.5 )

function stopNameChange(oldNick, newNick)
	if (source==getLocalPlayer()) then
		local legitNameChange = getElementData(getLocalPlayer(), "legitnamechange")

		if (oldNick~=newNick) and (legitNameChange==0) then
			triggerServerEvent("resetName", getLocalPlayer(), oldNick, newNick) 
			outputChatBox("Click 'Change Character' if you wish to change your roleplay identity.", 255, 0, 0)
		end
	end
end
addEventHandler("onClientPlayerChangeNick", getRootElement(), stopNameChange)